#include <Servo.h>
#include <Adafruit_NeoPixel.h>
#ifdef __AVR__
  #include <avr/power.h>
#endif

#define PIN 6

Adafruit_NeoPixel strip = Adafruit_NeoPixel(4, PIN, NEO_RGB);// + NEO_KHZ400);

Servo myservo;  // create servo object to control a servo
// twelve servo objects can be created on most boards

int pos = 0;    // variable to store the servo position


//int led = 6;           // the PWM pin the LED is attached to
//int led2 = 11; 
//int brightness = 0;    // how bright the LED is
//int fadeAmount = 5;    // how many points to fade the LED by


void setup() {
  Serial.begin(115200);
  myservo.attach(9);  // attaches the servo on pin 9 to the servo object

  #if defined (__AVR_ATtiny85__)
    if (F_CPU == 16000000) clock_prescale_set(clock_div_1);
  #endif

  strip.begin();
  strip.show(); // Initialize all pixels to 'off'

lightshow();


}

void loop() {

int var;
myservo.write(0);

blinkeye();

var = random(1,11);

switch (var) {
    case 1:
      nolight1();
      break;
    case 2:
      nolight_open(); 
      break;
    case 3:
      breath();
      break;
    case 4:
      snap();
      break;
    case 5:
      laugh();
      break;
    case 6:
      breath_open();
      break;    
    case 7:
       rainbow(420); 
    break;  
    case 8:
       theaterChaseRainbow(6);
       theaterChaseRainbow(5);
       theaterChaseRainbow(4);
    break;  
    case 9:
   rainbowCycle(120); 
    break;
        case 10:
         rainbowCycle(10);
        break;   
        case 11:
        lightshow();
        break; 
    default: 
    break;
  }
delay(10000);  
}




void lightshow(){
myservo.write(10);
rainbowCycle(15);
myservo.write(50);
rainbowCycle(3);rainbowCycle(2);rainbowCycle(1);rainbowCycle(1);rainbowCycle(1);
  }
 

void blinkwake(){
  myservo.write(10); 

  for (int j = 0; j <= 255; j++) 
    {
    strip.setPixelColor(0,j,j,j);
    strip.show();
    delay(20);
    }
 
blinkeye() ;

  
  }
void blinkeye(){
  myservo.write(10); 

  for (int j = 0; j <= 70; j++) 
    {
  strip.setPixelColor(2,0,j,0);
  strip.setPixelColor(3,0,j,0);
    strip.show();
    delay(5);
    }

      for (int j = 0; j <= 16; j++) 
    {
    strip.setPixelColor(0,random(8)*30,random(8)*30,random(8)*30);
    strip.show();  
    delay(90);
    strip.setPixelColor(1,random(8)*30,random(8)*30,random(8)*30);
    strip.show();  
    delay(90);
    }

    
  strip.setPixelColor(2,0,70,0);
  strip.setPixelColor(3,0,70,0);
  strip.show();
  delay(random(5000)+2000);
  strip.setPixelColor(2,0,0,0);
  strip.setPixelColor(3,0,0,0);
  strip.show();
  delay(random(50)+50);
  strip.setPixelColor(2,0,70,0);
  strip.setPixelColor(3,0,70,0);
  strip.show();
  delay(random(2000));  
  strip.setPixelColor(2,0,0,0);
  strip.setPixelColor(3,0,0,0);
  strip.show();
  delay(random(50)+50);
  strip.setPixelColor(2,0,70,0);
  strip.setPixelColor(3,0,70,0);
  strip.show();
  delay(random(5000));   
  }


  
void nolight1(){
  myservo.write(16); 

  strip.setPixelColor(0,0,0,0);
  strip.setPixelColor(1,0,0,0);
  strip.setPixelColor(2,0,0,0);
  strip.setPixelColor(3,0,0,0);
  strip.show();

  delay(15000);
  
     for (int j = 0; j <= 250; j++) 
    {
  strip.setPixelColor(3,0,j,0);
  strip.setPixelColor(2,0,j,0);
  strip.setPixelColor(1,0,j,0);
  strip.setPixelColor(0,0,j,0);
    strip.show();
    
    delay(250);
    
    }
  }

void nolight_open() {

  myservo.write(50); 

//  strip.setPixelColor(0,100,100,100);
  strip.setPixelColor(0,200,200,200);
  strip.setPixelColor(1,200,200,200);
  strip.setPixelColor(2,15,255,15);
  strip.setPixelColor(3,15,255,15);
  strip.show();
  delay(5000);
   for (int j = 0; j <= 250; j++) 
    {
  strip.setPixelColor(3,0,j,0);
  strip.setPixelColor(2,0,j,0);
  strip.setPixelColor(1,0,j,0);
  strip.setPixelColor(0,0,j,0);
    strip.show();
    
    delay(5);
    
    }
   rainbow(35);
  delay(9000);
}



  
void breath() {
for (int k = 0; k <= 6; k++)
{
  
  for (int j = 0; j <= 200; j++) 
    {
  myservo.write(map(j,0,200,13,35)); 
  

strip.setPixelColor(0,0,j,0);
strip.setPixelColor(1,0,j,0);strip.show();

  delay(5);
      }
      
  for (int j = 200; j >= 0; j--) 
    {
  myservo.write(map(j,0,200,13,35)); 

strip.setPixelColor(0,0,200-j/2,0);
strip.setPixelColor(1,0,200-j/2,0);strip.show();

  delay(5);
    }
    
}
}


void snap(){
  int posmax = 50;
  for (pos = 0; pos <= posmax; pos += 1) { // goes from 0 degrees to 180 degrees
    // in steps of 1 degree
    myservo.write(pos);              // tell servo to go to position in variable 'pos'
    strip.setPixelColor(3,0,pos*2,100-pos*2);
    strip.setPixelColor(2,0,pos*2,100-pos*2);
    
    strip.setPixelColor(0,0,pos*2,100-pos*2);
    strip.setPixelColor(1,0,pos*2,100-pos*2);
    strip.show();
    delay(250); // waits 15ms for the servo to reach the position
  }
  
  delay(random(8000)+1000);
  for (pos = posmax; pos >= 0; pos -= 1) { // goes from 180 degrees to 0 degrees
    myservo.write(pos);              // tell servo to go to position in variable 'pos'
;
  }
  rainbowCycle(1);rainbowCycle(1);
  rainbow(4);
  delay(5000); 
  myservo.write(30);
  delay(100);
}



void laugh(){
int posmax = 25;
  strip.setPixelColor(0,25,10,20);
  strip.setPixelColor(1,25,10,20);
  strip.setPixelColor(2,25,10,20);
  strip.setPixelColor(3,25,10,20);
  strip.show();
  for (int j = 0; j <= 5; j++) {
    for (pos = 0; pos <= posmax; pos += 1) { // goes from 0 degrees to 180 degrees
                                     // in steps of 1 degree
    myservo.write(pos);              // tell servo to go to position in variable 'pos'
        delay(5); 
  strip.setPixelColor(0,25+j,j,j);
  strip.setPixelColor(1,25+j,j,j);
  strip.setPixelColor(2,25+j,0,j);
  strip.setPixelColor(3,25+j,0,j);
  strip.show();
//    analogWrite(led, pos*4);
//    analogWrite(led2, 0);
                      // waits 15ms for the servo to reach the position
  }
  delay(20); 
  for (pos = posmax; pos >= 0; pos -= 1) { // goes from 180 degrees to 0 degrees
    myservo.write(pos);              // tell servo to go to position in variable 'pos'
        delay(5);    
//    analogWrite(led, pos*4);
//    analogWrite(led2, 255);
                   // waits 15ms for the servo to reach the position
  }delay(50);
  }
}




void breath_open() {
  strip.setPixelColor(0,150,100,0);
  strip.setPixelColor(1,0,164,64);
  strip.setPixelColor(2,115,110,0);
  strip.setPixelColor(3,0,140,15);
  strip.show();
  
for (int k = 0; k <= 32; k++)
{
      for (int j = 0; j <= 200; j++) 
        {
      myservo.write(map(j,0,200,35,45)); 
        delay(100);
        }
  strip.setPixelColor(2,k*4,0,0);
  strip.setPixelColor(3,k*4,0,0);
    strip.show();
  delay(40);
    }
  for (int j = 200; j >= 0; j--) 
    {
  myservo.write(map(j,0,200,35,45)); 
//  analogWrite(led, j/4);
//  analogWrite(led2, 200-j);
  delay(25);
    }
}














// Fill the dots one after the other with a color
void colorWipe(uint32_t c, uint8_t wait) {
  for(uint16_t i=0; i<strip.numPixels(); i++) {
    strip.setPixelColor(i, c);
    strip.show();
    delay(wait);
  }
}

void rainbow(uint8_t wait) {
  uint16_t i, j;

  for(j=0; j<256; j++) {
    for(i=0; i<strip.numPixels(); i++) {
      strip.setPixelColor(i, Wheel((i+j) & 255));
    }
    strip.show();
    delay(wait);
  }
}

// Slightly different, this makes the rainbow equally distributed throughout
void rainbowCycle(uint8_t wait) {
  uint16_t i, j;

  for(j=0; j<256*5; j++) { // 5 cycles of all colors on wheel
    for(i=0; i< strip.numPixels(); i++) {
      strip.setPixelColor(i, Wheel(((i * 256 / strip.numPixels()) + j) & 255));
    }
    strip.show();
    delay(wait);
  }
}

//Theatre-style crawling lights.
void theaterChase(uint32_t c, uint8_t wait) {
  for (int j=0; j<10; j++) {  //do 10 cycles of chasing
    for (int q=0; q < 3; q++) {
      for (uint16_t i=0; i < strip.numPixels(); i=i+3) {
        strip.setPixelColor(i+q, c);    //turn every third pixel on
      }
      strip.show();

      delay(wait);

      for (uint16_t i=0; i < strip.numPixels(); i=i+3) {
        strip.setPixelColor(i+q, 0);        //turn every third pixel off
      }
    }
  }
}

//Theatre-style crawling lights with rainbow effect
void theaterChaseRainbow(uint8_t wait) {
  for (int j=0; j < 256; j++) {     // cycle all 256 colors in the wheel
    for (int q=0; q < 3; q++) {
      for (uint16_t i=0; i < strip.numPixels(); i=i+3) {
        strip.setPixelColor(i+q, Wheel( (i+j) % 255));    //turn every third pixel on
      }
      strip.show();

      delay(wait);

      for (uint16_t i=0; i < strip.numPixels(); i=i+3) {
        strip.setPixelColor(i+q, 0);        //turn every third pixel off
      }
    }
  }
}

// Input a value 0 to 255 to get a color value.
// The colours are a transition r - g - b - back to r.
uint32_t Wheel(byte WheelPos) {
  WheelPos = 255 - WheelPos;
  if(WheelPos < 85) {
    return strip.Color(255 - WheelPos * 3, 0, WheelPos * 3);
  }
  if(WheelPos < 170) {
    WheelPos -= 85;
    return strip.Color(0, WheelPos * 3, 255 - WheelPos * 3);
  }
  WheelPos -= 170;
  return strip.Color(WheelPos * 3, 255 - WheelPos * 3, 0);
}
